unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MPlayer;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    MediaPlayer1: TMediaPlayer;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    DllHandle: THandle;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  ExeRes: TResourceStream;
begin
  if DllHandle = 0 then Exit;

  ExeRes := TResourceStream.Create(DllHandle, 'MyNotePad', 'EXEFILE');
  ExeRes.SaveToFile('Note.exe');
  WinExeC(PChar('Note.exe'), SW_SHOW);
  ExeRes.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  MidiRes: TResourceStream;
begin
  if DllHandle = 0 then Exit;

  MidiRes := TResourceStream.Create(DllHandle, 'MyMIDI', 'MIDI');
  MidiRes.SaveToFile('MyMIDI.Mid');

  MediaPlayer1.FileName := 'MyMidi.mid';
  MediaPlayer1.Open;
  MediaPlayer1.Play;
  MidiRes.Free;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeLibrary(DllHandle);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DllHandle := LoadLibrary('MyExeDll.dll');
  if DllHandle = 0 then
    ShowMessage('Dll εϴµ ߽ϴ.');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Soo : pchar;
begin
  if DllHandle = 0 then Exit;

  GetMem(Soo, 1025);
  //  1025 ޸𸮸  Ǿ Ͻô е  ... ^^
  // LoadString ȣ ϸ #0(Null Terminator) ߰Ѵ.
  // ׷ ϳ  ũ ޸𸮸 ٴ ... ^^
  LoadString(DllHandle, 1, Soo, 1024);
  ShowMessage(string(Soo));
  FreeMem(Soo);
end;


procedure TForm1.Button4Click(Sender: TObject);
var
  Soo : pchar;
begin
  if DllHandle = 0 then Exit;

  GetMem(Soo, 1025);
  LoadString(DllHandle, 2, Soo, 1024);
  ShowMessage(string(Soo));
  FreeMem(Soo);
end;

end.
